org.apache.cayenne.access.jdbc

## Class BatchAction

- java.lang.Object
- - org.apache.cayenne.access.jdbc.BaseSQLAction
  - - org.apache.cayenne.access.jdbc.BatchAction

- All Implemented Interfaces:
    SQLAction
  Direct Known Subclasses:
    SQLServerBatchAction

      public class BatchAction
      extends BaseSQLAction

  Since:
    1.2

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `batch`
    `protected RowDescriptor` | `keyRowDescriptor`
    `protected BatchQuery` | `query`

    - ### Fields inherited from class org.apache.cayenne.access.jdbc.BaseSQLAction

      `adapter, entityResolver`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BatchAction(BatchQuery batchQuery, JdbcAdapter adapter, EntityResolver entityResolver)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected BatchQueryBuilder` | `createBuilder()`
    `BatchQuery` | `getQuery()`
    `protected boolean` | `hasGeneratedKeys()` Returns whether BatchQuery generates any keys.
    `boolean` | `isBatch()`
    `void` | `performAction(Connection connection, OperationObserver observer)` Executes a query using a strategy defined by the implementation.
    `protected void` | `processGeneratedKeys(Statement statement, OperationObserver observer)` Implements generated keys extraction supported in JDBC 3.0 specification.
    `protected void` | `runAsBatch(Connection con, BatchQueryBuilder queryBuilder, OperationObserver delegate)`
    `protected void` | `runAsIndividualQueries(Connection connection, BatchQueryBuilder queryBuilder, OperationObserver delegate, boolean generatesKeys)` Executes batch as individual queries over the same prepared statement.
    `void` | `setBatch(boolean runningAsBatch)`

    - ### Methods inherited from class org.apache.cayenne.access.jdbc.BaseSQLAction

      `getAdapter, getEntityResolver, getInMemoryOffset, readResultSet`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### batch

          protected boolean batch

    - #### query

          protected BatchQuery query

    - #### keyRowDescriptor

          protected RowDescriptor keyRowDescriptor

  - ### Constructor Detail

    - #### BatchAction

          public BatchAction(BatchQuery batchQuery,
                             JdbcAdapter adapter,
                             EntityResolver entityResolver)

  - ### Method Detail

    - #### getQuery

          public BatchQuery getQuery()

      Returns:
        Query which originated this action

    - #### isBatch

          public boolean isBatch()

    - #### setBatch

          public void setBatch(boolean runningAsBatch)

    - #### performAction

          public void performAction(Connection connection,
                                    OperationObserver observer)
                             throws SQLException,
                                    Exception

      Description copied from interface: `SQLAction`
      Executes a query using a strategy defined by the implementation.
      Throws:
        `SQLException`
        `Exception`

    - #### createBuilder

          protected BatchQueryBuilder createBuilder()
                                             throws CayenneException

      Throws:
        `CayenneException`

    - #### runAsBatch

          protected void runAsBatch(Connection con,
                                    BatchQueryBuilder queryBuilder,
                                    OperationObserver delegate)
                             throws SQLException,
                                    Exception

      Throws:
        `SQLException`
        `Exception`

    - #### runAsIndividualQueries

          protected void runAsIndividualQueries(Connection connection,
                                                BatchQueryBuilder queryBuilder,
                                                OperationObserver delegate,
                                                boolean generatesKeys)
                                         throws SQLException,
                                                Exception

      Executes batch as individual queries over the same prepared statement.
      Throws:
        `SQLException`
        `Exception`

    - #### hasGeneratedKeys

          protected boolean hasGeneratedKeys()

      Returns whether BatchQuery generates any keys.

    - #### processGeneratedKeys

          protected void processGeneratedKeys(Statement statement,
                                              OperationObserver observer)
                                       throws SQLException,
                                              CayenneException

      Implements generated keys extraction supported in JDBC 3.0 specification.
      Throws:
        `SQLException`
        `CayenneException`

Copyright © 2001–2018 Apache Cayenne. All rights reserved.